#pragma once
// windows kits\10\include\10.0.17763.0\shared\rpcndr.h(192): error C2872: 'byte': ambiguous symbol
//#ifdef _HAS_STD_BYTE
//#undef _HAS_STD_BYTE
//#define _HAS_STD_BYTE 0
//#endif

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <iostream>
#include <fstream>
#include <sstream>
#include <random>
#include <ctime>
#include <chrono>

#include <limits>
#include <algorithm>


// 'using namespace std;' will bring std::byte(C++17 std), 
// which conflict with 'byte' defined in SDK,
// and define _HAS_STD_BYTE take no effect,
// as a workaround, we do not use the global namespace std.
// using namespace std;

// disable SDL checks to prevent error C4996 
#pragma warning(disable: 4996)

// Set the version of Xapian to use:
// XAPIAN_1_2_25(1.2.25), XAPIAN_1_4_25(1.4.25)
// Remember to change "Additional Include Directories" and 
// "Additional Library Directories" in MSVC project
#define XAPIAN_1_4_25

#include "xapian.h"

#ifdef XAPIAN_1_2_25
#pragma comment(lib, "libapi.lib")
#pragma comment(lib, "libbackend.lib")
#pragma comment(lib, "libbrass.lib")
#pragma comment(lib, "libbrassbtreecheck.lib")
#pragma comment(lib, "libchert.lib")
#pragma comment(lib, "libchertbtreecheck.lib")
#pragma comment(lib, "libcommon.lib")
#pragma comment(lib, "libexpand.lib")
#pragma comment(lib, "libflint.lib")
#pragma comment(lib, "libflintbtreecheck.lib")
#pragma comment(lib, "libinmemory.lib")
#pragma comment(lib, "liblanguages.lib")
#pragma comment(lib, "libmatcher.lib")
#pragma comment(lib, "libmulti.lib")
#pragma comment(lib, "libnet.lib")
#pragma comment(lib, "libqueryparser.lib")
#pragma comment(lib, "libremote.lib")
#pragma comment(lib, "libunicode.lib")
#pragma comment(lib, "libweight.lib")
#elif defined(XAPIAN_1_4_25)
#pragma comment(lib, "libxapian.lib")
#pragma comment(lib, "libgetopt.lib")
#else
#error "You can only specify Xapian version to 1.2.25 or 1.4.25 at present!"
#endif

#pragma comment(lib, "zlib.lib")
#pragma comment(lib, "rpcrt4.lib")
#pragma comment(lib, "ws2_32.lib")


// #define SPECIFY_TYPE_IN_STD_INPUT

// Uncomment it to use tempory Xapian::Query object
#define USE_GLOBAL_XAPIAN_QUERY_OBJECT
